program make_irc;
{
  ᯮ⥫쭠 ணࠬ  IRC (Infrared Remote Control)
   1.0 ( DOS)
  (C) 1997, ᠭ ⬠

  ணࠬ 뢠 䠩 䨣樨,  ண  
  ࠬ஬  ப,  ᠬ 䠩  ᫥騩 ଠ:

      ⠭ VCR-䠩,    ਬ: copy %1 current.vcr
      ⠭ VCR-䠩, ਬ: copy standard.vcr current.vcr
      ஢ ,     ਬ: _avirc %1
      ᪠ batch-䠩,      ਬ: arvid32.exe -Yc:\command.com %1

       Vcr  
       Vcr  
     ...
       Vcr  

    --  ப    15,  ᮤঠ
  ஡   稭  ᨬ "@" (ਬ, VCR:PLAY  TV-1),
  Vcr --  VCR-䠩, ᮤঠ饣 ᠭ -
  㯯  (ਬ, TV001.vcr),  -- ᫮  0  15,
  饥 浪  뢠   VCR-䠩.
  ᫮ ᠭ    ॢ 127.

  ன ࠬ  ப --   ᮧ batch-䠩
  (ਬ, $irc$.bat), ⨩ ࠬ --  㣮 ᯮ⥫쭮
  batch-䠩, ᮧ   ᯮ塞  䮭 ࠩ ࢨ
  (ਬ, $$irc$$.bat).

    ᫥ ࠬ஢    , 
    @,   --  䠩, ᮤঠ饣 -
  ᯨ᮪    ᯮ (     ப).
   ᯨ᮪ ࠬ஢, ணࠬ ᮧ ६
  batch-䠩   $IRC$.BAT, ᫥ ᯮ ண
  ࢨ 諥 ᨣ 㪠   ⥫ / 䮭.
  ணࠬ ⮫쪮 ᮧ batch-䠩 $IRC$.BAT,   ᯮ .
}

{$I-}

const
  wildCard = '%1';
  filePrefix = '@';
  maxNumButtons = 127;

type
  tButton = record
    name: string[15];
    vcr:  string[12];
    num:  string[2];
  end;

var
  cfgFile, batFile: text;
  vcrCommand, resCommand, ircCommand, runCommand: string;
  cfgFileName, batFileName, ircFileName: string;
  button: array [1..maxNumButtons] of tButton;
  currentVCR: string[12];
  numButtons: integer;

procedure help;
begin
  writeln;
  writeln('This is an auxiliary program for IRC (Infrared Remote Control)');
  writeln('version 1.0 (for DOS), (C) 1997, Alexander E. Gutman');
  writeln('IRC, in its turn, is an auxiliary program for Arvid (TM)');
  writeln;
  writeln('Usage:  MAKE_IRC <config> <aux1> <aux2> <button> [<button> ...]');
  writeln;
  writeln('  where <config> is the name of a configuration file');
  writeln('  (see READ.ME for the description of its format),');
  writeln('  <aux1> and <aux2> are the names of auxiliary batch-files,');
  writeln('  and <button> is either a name of a button');
  writeln('  (one of those listed in the configuration file)');
  writeln('  or a parameter of the form @<filename>,');
  writeln('  where <filename> is the name of a file');
  writeln('  with a set of button names, one per line.');
  writeln;
  halt(1);
end;

procedure assert(cond: boolean; message: string);
begin
  if not cond then begin writeln(message); halt(1); end;
end;

function upCaseStr(s: string): string;
var i: integer; t: string;
begin
  t := '';
  for i := 1 to length(s) do t := t + upCase(s[i]);
  upCaseStr := t;
end;

procedure readNext(var f: text; var s: string);
{
  ⠥  s ᫥  ப 䠩 f.
   s := ''  㦥  䠩.
}
begin
  s := '';
  while (not eof(f)) and (s = '') do begin
    readln(f,s);
    assert(ioResult=0,'Error reading a file');
    while (s <> '') and (s[1] = ' ') do delete(s,1,1);
    while (s <> '') and (s[length(s)] = ' ') do delete(s,length(s),1);
  end;
end;

function replace(where,what,by: string): string;
{ 頥 祭 where,   宦 what   by. }
var s: string; i: integer;
begin
  s := where;
  repeat
    i := pos(what,s);
    if i <> 0 then
      s := copy(s,1,i-1) + by + copy(s,i+length(what),255);
  until i = 0;
  replace := s;
end;

procedure readConfig;
{
  ⠥ 䨣樮 䠩, । 祭
  cfgFileName, batFileName, ircFileName,
  vcrCommand, resCommand, ircCommand, runCommand, numButtons
   뢠     ᨢ button.
}
var s: string; i: integer;
begin
  assert(paramCount > 3,'At least 4 parameters expected');
  cfgFileName := paramStr(1);
  batFileName := paramStr(2);
  ircFileName := paramStr(3);
  assign(cfgFile,cfgFileName);
  reset(cfgFile); assert(ioResult=0,'Cannot open '+cfgFileName);
  readNext(cfgFile,vcrCommand); assert(vcrCommand<>'','Unexpected end of '+cfgFileName);
  readNext(cfgFile,resCommand); assert(resCommand<>'','Unexpected end of '+cfgFileName);
  readNext(cfgFile,ircCommand); assert(ircCommand<>'','Unexpected end of '+cfgFileName);
  readNext(cfgFile,runCommand); assert(runCommand<>'','Unexpected end of '+cfgFileName);
  runCommand := replace(runCommand,wildCard,ircFileName);
  numButtons := 0;
  repeat
    readNext(cfgFile,s);
    if s <> '' then begin
      inc(numButtons);
      assert(numButtons <= maxNumButtons,'Too many buttons described');
      i := pos(' ',s);
      assert(i > 1, 'Invalid button description in '+cfgFileName);
      button[numButtons].name := upCaseStr(copy(s,1,i-1));
      delete(s,1,i); while (s <> '') and (s[1] = ' ') do delete(s,1,1);
      i := pos(' ',s);
      assert(i > 1, 'Invalid button description in '+cfgFileName);
      button[numButtons].vcr := upCaseStr(copy(s,1,i-1));
      delete(s,1,i); while (s <> '') and (s[1] = ' ') do delete(s,1,1);
      assert((s <> '') and (length(s) <= 2),
             'Invalid button description in '+cfgFileName);
      button[numButtons].num := s;
    end;
  until s = '';
  close(cfgFile); assert(ioResult=0,'Cannot close '+cfgFileName);
end;

procedure order(buttonName: string);
{ 頥   ""  buttonName  䠩 batFile. }
var n: integer;
begin
  buttonName := upCaseStr(buttonName);
  n := 0;
  repeat
    inc(n);
  until (n > numButtons) or (button[n].name = buttonName);
  assert(n <= numButtons, 'Unknown button name: '+buttonName);
  if currentVCR <> button[n].vcr then begin
    if currentVCR = '' then begin
      writeln(batFile,'echo @echo off>',ircFileName);
    end else begin
      writeln(batFile,'echo exit>>',ircFileName);
      writeln(batFile,runCommand);
    end;
    currentVCR := button[n].vcr;
    writeln(batFile,replace(vcrCommand,wildCard,currentVCR));
  end;
  writeln(batFile,'echo ',replace(ircCommand,wildCard,button[n].num),'>>',ircFileName);
  assert(ioResult=0,'Error writing into '+batFileName);
end;

var
  s,t: string;
  n: integer;
  f: text;

begin
  if paramCount < 4 then help;
  readConfig;
  assign(batFile,batFileName);
  rewrite(batFile); assert(ioResult=0,'Cannot create '+batFileName);
  writeln(batFile,'@echo off');
  assert(ioResult=0,'Error writing into '+batFileName);
  currentVCR := '';
  for n := 4 to paramCount do begin
    s := paramStr(n);
    if s[1] = filePrefix then begin
      delete(s,1,1);
      assert(s <> '','Invalid parameter: '+filePrefix);
      assign(f,s); reset(f); assert(ioResult=0,'Cannot open '+s);
      repeat
        readNext(f,t);
        if t <> '' then order(t);
      until t = '';
      close(f); assert(ioResult=0,'Cannot close '+s);
    end else begin
      order(s);
    end;
  end;
  writeln(batFile,'echo exit>>',ircFileName);
  writeln(batFile,runCommand);
  writeln(batFile,resCommand);
  assert(ioResult=0,'Error writing into '+batFileName);
  close(batFile); assert(ioResult=0,'Cannot close '+batFileName);
end.
