/*
 *  $ReleaseID$
 *
 *  $Id$
 */

#include <unistd.h>
#include <linux/sched.h>
#include <linux/ioport.h>
#include <asm/system.h>
#include <asm/irq.h>
#include <asm/io.h>
#include "arvid.h"
#include "arv-data.h"
#include "arv-ll.h"
#include "arv-isr.h"
#include "arv-io.h"

volatile void (*real_hdlr)(void) = NIL;

byte *buffer[DRV_BUFNUM];

volatile int  hwbptr=0;
volatile int  bufptr=0;
volatile int  bufnum=0;
volatile word clk=0;
volatile int  hdlr_busy=0;

void irq_hdlr(int irq, void *dev_id, struct pt_regs *regs) {
  clk++;
  if(hdlr_busy++) {
    arvid.irq_lost++;
    return;
  }
  arv_statupdate();
  if(real_hdlr != NIL) (*real_hdlr)();
  wake_up_interruptible(&arvid_waitq);
  hdlr_busy--;
}

void read_hdlr(void) {
  int bufrdy;
  dword flags;
  save_flags(flags);
  cli();
  for(bufrdy=bufcnt(); bufrdy>0 && bufnum>0; bufrdy--) {
    rbuf(hwbptr,buffer[bufptr]);
    port_cmd(currmode+IBUF);
    port_cmd(currmode);
    hwbptr = ++hwbptr % 8;
    bufptr = ++bufptr % DRV_BUFNUM;
    bufnum--;
  }
  if(bufnum == 0) real_hdlr=NIL;
  sti();
  restore_flags(flags);
}

void write_hdlr(void) {
  int bufrdy;
  dword flags;
  save_flags(flags);
  cli();
  for(bufrdy=7-bufcnt(); bufrdy>0 && bufnum>0; bufrdy--) {
    wbuf(hwbptr,buffer[bufptr]);
    port_cmd(currmode+IBUF);
    port_cmd(currmode);
    hwbptr = ++hwbptr % 8;
    bufptr = ++bufptr % DRV_BUFNUM;
    bufnum--;
  }
  if(bufnum == 0) real_hdlr=NIL;
  sti();
  restore_flags(flags);
}
