/*
 *  $ReleaseID$
 *
 *  $Id$
 */

#include <unistd.h>
#include <linux/sched.h>
#include <linux/ioport.h>
#include <asm/system.h>
#include <asm/irq.h>
#include <asm/io.h>
#include "arvid.h"
#include "arv-hlp.h"
#include "arv-data.h"
#include "arv-ll.h"

void port_cmd(word cmd)   { outw(cmd,arvid.iobase+PCMD); }
word port_stat()          { return inw(arvid.iobase+PSTAT); }
void port_addr(word adr)  { outw(adr,arvid.iobase+PADR); }
void port_wdat(word dat)  { outw(dat,arvid.iobase+PDAT); }
word port_rdat()          { return inw(arvid.iobase+PDAT); }
void port_wdati(word dat) { outw(dat,arvid.iobase+PIDAT); }
word port_rdati()         { return inw(arvid.iobase+PIDAT); }

word bufadr2badr(int buf,int adr) {
  return (adr & 0xf) | ((buf << 4) & 0x70);
}

int badr2buf(int badr) {
  return ((badr >> 4) & 0x7);
}

int badr2adr(int badr) {
  return (badr & 0xf);
}

word phs2cmd(word phs) {
  return ((phs << 5) & 0xe0);
}

int bufcnt() {
  return port_stat() & 0x7;
}

int looperr() {
  return (port_stat() & 0x8) == 0;
}

int atrk() {
  return (port_stat() & 0x10) != 0;
}

void wbuf(int bnum, byte *data) {
  word *wptr=(word*)data;
  int i,adr=0,badr;
  for(badr=0; badr<16; badr++) {
    port_addr(bufadr2badr(bnum,badr));
    port_wdat(wptr[adr]);
    for(i=0; i<256; i++) port_wdati(wptr[adr++]);
  }
}

void rbuf(int bnum, byte *data) {
  word *wptr=(word*)data;
  int i,adr=0,badr;
  for(badr=0; badr<16; badr++) {
    port_addr(bufadr2badr(bnum,badr));
    wptr[adr]=port_rdat();
    for(i=0; i<256; i++) wptr[adr++]=port_rdati();
  }
}
