/*
 *      
 */

#include "stdio.h"
#include "ctype.h"
#include "string.h"
#include "sys/ioctl.h"

#include "Irc.hpp"
#include "avtreg.h"

/*    */
#if 0
Config		Cfg;
#else
char		*CfgDev = "/dev/ravt0";
char		*CfgTdr = "/usr/local/lib/arvid/tdr";
char		*CfgAvt = "/usr/local/lib/arvid/avt";
char		*CfgVcrd = "/usr/local/lib/arvid";
char		*CfgVcr = "akair110.vcr";
char		*CfgLog = "/var/log/arvid/arvid.log";
char		*CfgErr = "/var/log/arvid/arvid.err";
char		CfgPhase = 2;
#endif
int		arvidio;	/*    */
struct set_rw	SetRW;		/*    */

VCR	Vcr;		/*  VCR */

u_int		debug = 0xff;	/* 0000 0000 1111 1111 */
/*       */
#define		SIZECMDSTR	1024
char		cmdstr[SIZECMDSTR];
char		*pcmdstr;

void	ParseCmdf(FILE *cmdfile);
void	RunCommand(char *cstr, int size);
int	IrcCommand(char *cstr, int size);

int main(int argc, char *argv[]) {
FILE	*cmdfile;		/*     */
int	ncmdf=0;		/*     */

	/*      */
	if (argc < 2) {
		printf("Usage: %s <command.file> [<command.file> [..]]\n", argv[0]);
		return(1);
		}
	/*  */
	arvidio = 0;
	/*    */
	//	Cfg.Read();

	/*     */
	for (ncmdf=1; argc > ncmdf; ncmdf++) {
		cmdfile = fopen(argv[ncmdf], "r");
		if (cmdfile == (FILE *)0)
			printf("Error open %s file\n", argv[ncmdf]);
		else	{
			ParseCmdf(cmdfile);
			fclose(cmdfile);
			}; /* cmdfile */
		}; /* for (ncmd++) */

	/*   */
	if (arvidio)
		close(arvidio);
	/*   */
	return(0);
};

/*
 *  
 */
void ParseCmdf(FILE *cmdfile) {
	while (fgets(cmdstr, SIZECMDSTR, cmdfile)) {
		/*   */
		if ((cmdstr[0] == '#') || (cmdstr[0] == '\n')) {
			printf("ignore line: %s", cmdstr);
			}
		else	{
			RunCommand(cmdstr, SIZECMDSTR);
			}
		}; /* while */
};

/*
 *   
 * : <, >
 */
void RunCommand(char *cstr, int size) {
int	sz;
char	*pcstr;

	/*  '\n' */
	sz = 0;
	pcstr = cstr;
	while (isprint(*pcstr) && (sz++ < size)) pcstr++;
	*pcstr = '\0';

	printf(": %s\n", cmdstr);
	/*    */
	sz = 0;
	pcstr = cstr;
	while ((isblank(*pcstr)) && (sz++ < size)) pcstr++;
	/*   */
	if (strncasecmp(pcstr, "IDENT", 5) == 0) {
		printf("IDENT command found\n");
		}
	else if (strncasecmp(pcstr, "IRC", 3) == 0) {
		pcstr += 3;
		sz += 3;
		printf("IRC command: %s\n", pcstr);
		IrcCommand(pcstr, size - sz);
		}
	else	{
		printf("Error command, ignore\n");
		};
};

/*
 *    .
 * 0 - OK
 */
int IrcCommand(char *cstr, int size) {
int	sz;

	sz = 0;
	while ((isblank(*cstr)) && (sz++ < size)) cstr++;
	/*  VCR    */
	if (Vcr.fvcr == 0) {
		char	*vcrtmp;
		int	len;

		len = strlen(CfgVcrd);
		len += strlen(CfgVcr);
		len += 2;
		vcrtmp = (char *)malloc(len);
		strcpy(vcrtmp, CfgVcrd);
		strcat(vcrtmp, "/");
		strcat(vcrtmp, CfgVcr);
		printf("Loading VCR: %s\n", vcrtmp);
		if (Vcr.LoadVCR(vcrtmp)) {
			printf("Error loading VCR: %s\n", vcrtmp);
			free(vcrtmp);
			return(1);
			};
		free(vcrtmp);
		};
	/*     */
	if (arvidio == 0) {
		arvidio = open(CfgDev, O_RDWR, 0);
		if (arvidio < 0) {
			printf("Error open %s\n", CfgDev);
			return(1);
			};
		};
	/*   */
	SetRW.rate = 200;
	SetRW.flag = IOIRC;
	ioctl(arvidio, VSET_WRITE, &SetRW);
	/*   */
	return(Vcr.IrcKeyTrn(arvidio, cstr));
};
